﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.ListControls;

namespace WebDataGrid
{
    public partial class DropDownProviderPerRow : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {            

            WebDataGrid1.DataSource = SampleData.GetShadeColorDataTable();
            WebDataGrid1.DataBind();

        }

        protected void ShadeDDP_ItemsRequested(object sender , DropDownItemsRequestedEventArgs e)
        {
            DataTable dt = SampleData.GetShadeDataTable();

            int colorId = 0;
            int.TryParse(e.Value.ToString(), out colorId);

            // find the shades that match the passed ColorId
            DataRow[] shades = dt.Select("ColorId = " + colorId.ToString());
            for (int i = dt.Rows.Count -1; i>=0; i--)
            {
                if (!shades.Contains(dt.Rows[i]))
                {
                    dt.Rows.RemoveAt(i);
                }
                
            }
                       
            ShadeDDP.EditorControl.Items.Clear();
            ShadeDDP.EditorControl.DataSource = dt;
            ShadeDDP.EditorControl.DataBind();

            // simulate a long database call
            System.Threading.Thread.Sleep(1000);
        }

    }
}