﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebDataGridTemplate.aspx.cs" Inherits="WebDataGrid.WebDataGridTemplate" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    <ig:WebScriptManager ID="WebScriptManager1" runat="server" />

        <ig:WebDataGrid ID="WebDataGrid1" runat="server" Height="350px" Width="400px" 
            AutoGenerateColumns="False" >
            <Columns>
                <ig:TemplateDataField Key="PersonNameColumn">
                    <ItemTemplate>
                        <span style="background-color: #ff7777">
                        <%# DataBinder.Eval(((Infragistics.Web.UI.TemplateContainer)Container).DataItem, "PersonName") %>
                        </span>
                        <br />
                        <span style="background-color: #77ff77">
                        <%# DataBinder.Eval(((Infragistics.Web.UI.TemplateContainer)Container).DataItem, "ColorName")%>
                        </span>
                    </ItemTemplate>
                    <Header Text="Person Name" />
                </ig:TemplateDataField>

                <ig:BoundDataField DataFieldName="ColorName" Key="ColorColumn">
                    <Header Text="Favorite Color" />
                </ig:BoundDataField>
            </Columns>
            <EditorProviders>
                <ig:DropDownProvider ID="ddpColor">
                    <EditorControl ClientIDMode="Predictable" DropDownContainerMaxHeight="200px" 
                        EnableAnimations="False" EnableDropDownAsChild="False" TextField="ColorName" 
                        ValueField="ColorId">
                        <DropDownItemBinding TextField="ColorName" ValueField="ColorId" />
                    </EditorControl>
                </ig:DropDownProvider>
            </EditorProviders>
            <Behaviors>
                <ig:RowSelectors>
                </ig:RowSelectors>
                <ig:Selection>
                </ig:Selection>
                <ig:EditingCore>

                    <Behaviors>
                        <ig:CellEditing>
                            <ColumnSettings>
                                <ig:EditingColumnSetting ColumnKey="ColorColumn" EditorID="ddpColor" />
                                <ig:EditingColumnSetting ColumnKey="PersonNameColumn" EditorID="ddpColor" />
                            </ColumnSettings>
                            <EditModeActions MouseClick="Single" />
                        </ig:CellEditing>
                    </Behaviors>
                </ig:EditingCore>
            </Behaviors>
        </ig:WebDataGrid>        
        
    </div>
    </form>

</body>
</html>
